#ifndef	PEXEXTLIB_H
#define	PEXEXTLIB_H

/* Common Open Systems Environment, Common Graphics Environment  */		
/* Extension to PEX 5.1 version 2.  File date: April 14, 1994    */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS       */
/*  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT SHALL SUN MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL,       */
/*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                             */
/*									      */
/******************************************************************************/

#include <X11/PEX5/PEXExt.h>
#include <X11/Xfuncproto.h>

/*
 * Ext type definitions
 */

typedef	XID		PEXExtTextureMap;
typedef	XID		PEXExtTMDescription;

/*
 * Ext output primitive	and attribute
 */

/* Ext vertex data */
typedef	union {
    PEXCoord			*no_data;
    PEXVertexIndexed		*index;
    PEXVertexRGB		*rgb;
    PEXVertexHSV		*hsv;
    PEXVertexHLS		*hls;
    PEXVertexCIE		*cie;
    PEXVertexRGB8		*rgb8;
    PEXVertexRGB16		*rgb16;
    PEXVertexNormal		*normal;
    PEXVertexEdge		*edge;
    PEXVertexIndexedNormal	*index_normal;
    PEXVertexRGBNormal		*rgb_normal;
    PEXVertexHSVNormal		*hsv_normal;
    PEXVertexHLSNormal		*hls_normal;
    PEXVertexCIENormal		*cie_normal;
    PEXVertexRGB8Normal		*rgb8_normal;
    PEXVertexRGB16Normal	*rgb16_normal;
    PEXVertexIndexedEdge	*index_edge;
    PEXVertexRGBEdge		*rgb_edge;
    PEXVertexHSVEdge		*hsv_edge;
    PEXVertexHLSEdge		*hls_edge;
    PEXVertexCIEEdge		*cie_edge;
    PEXVertexRGB8Edge		*rgb8_edge;
    PEXVertexRGB16Edge		*rgb16_edge;
    PEXVertexNormalEdge		*normal_edge;
    PEXVertexIndexedNormalEdge	*index_normal_edge;
    PEXVertexRGBNormalEdge	*rgb_normal_edge;
    PEXVertexHSVNormalEdge	*hsv_normal_edge;
    PEXVertexHLSNormalEdge	*hls_normal_edge;
    PEXVertexCIENormalEdge	*cie_normal_edge;
    PEXVertexRGB8NormalEdge	*rgb8_normal_edge;
    PEXVertexRGB16NormalEdge	*rgb16_normal_edge;
    PEXPointer			with_fp_data;
} PEXExtArrayOfVertex;

typedef	struct {
    unsigned long	count;			/* number of vertices */
    PEXExtArrayOfVertex	vertices;		/* pointer to vertices */
} PEXExtListOfVertex;

/* Ext texture OCs */
typedef	struct {
    unsigned short		count;		/* number of indices*/
    PEXTableIndex		*indices;
} PEXExtListOfTexture;

typedef	struct {
    PEXEnumTypeIndex		optimization;
    PEXExtListOfTexture		prioritized_textures;
} PEXExtTextureResourceHints;

/*
 * Ext pipeline	context
 */
typedef	struct {
    PEXEnumTypeIndex		mode;
    PEXEnumTypeIndex		blend_op;
} PEXExtPrimitiveAA;

typedef	struct {
    PEXEnumTypeIndex	marker_type;
    float		marker_scale;
    PEXColorSpecifier	marker_color;
    PEXTableIndex	marker_bundle_index;
    PEXTableIndex	text_font;
    unsigned short	text_precision;
    float		char_expansion;
    float		char_spacing;
    PEXColorSpecifier	text_color;
    float		char_height;
    PEXVector2D		char_up_vector;
    unsigned short	text_path;
    PEXTextAlignment	text_alignment;
    float		atext_height;
    PEXVector2D		atext_up_vector;
    unsigned short	atext_path;
    PEXTextAlignment	atext_alignment;
    PEXEnumTypeIndex	atext_style;
    PEXTableIndex	text_bundle_index;
    PEXEnumTypeIndex	line_type;
    float		line_width;
    PEXColorSpecifier	line_color;
    PEXCurveApprox	curve_approx;
    PEXEnumTypeIndex	polyline_interp;
    PEXTableIndex	line_bundle_index;
    PEXEnumTypeIndex	interior_style;
    PEXTypeOrTableIndex	interior_style_index;
    PEXColorSpecifier	surface_color;
    PEXReflectionAttributes	reflection_attr;
    PEXEnumTypeIndex	reflection_model;
    PEXEnumTypeIndex	surface_interp;
    PEXEnumTypeIndex	bf_interior_style;
    PEXTypeOrTableIndex	bf_interior_style_index;
    PEXColorSpecifier	bf_surface_color;
    PEXReflectionAttributes	bf_reflection_attr;
    PEXEnumTypeIndex	bf_reflection_model;
    PEXEnumTypeIndex	bf_surface_interp;
    PEXSurfaceApprox	surface_approx;
    unsigned short	culling_mode;
    Bool		distinguish;
    PEXCoord2D		pattern_size;
    PEXCoord		pattern_ref_point;
    PEXVector		pattern_ref_vec1;
    PEXVector		pattern_ref_vec2;
    PEXTableIndex	interior_bundle_index;
    PEXSwitch		surface_edges;
    PEXEnumTypeIndex	surface_edge_type;
    float		surface_edge_width;
    PEXColorSpecifier	surface_edge_color;
    PEXTableIndex	edge_bundle_index;
    PEXMatrix		local_transform;
    PEXMatrix		global_transform;
    unsigned short	model_clip;
    PEXModelClipVolume	model_clip_volume;
    PEXTableIndex	view_index;
    PEXListOfLight	light_state;
    PEXTableIndex	depth_cue_index;
    PEXBitmask		asf_enables;
    PEXBitmask		asf_values;
    long		pick_id;
    unsigned long	hlhsr_id;
    PEXNameSet		name_set;
    PEXTableIndex	color_approx_index;
    PEXEnumTypeIndex	rendering_color_model;
    PEXPSCSpecifier	para_surf_char;
    PEXEnumTypeIndex	tm_perspective_correction;
    PEXExtTextureResourceHints	tm_resource_hints;
    PEXEnumTypeIndex	tm_sample_frequency;
    PEXExtListOfTexture	active_textures;
    PEXExtListOfTexture	bf_active_textures;
    PEXExtPrimitiveAA	primitive_aa;
    PEXEnumTypeIndex	line_cap_style;
    PEXEnumTypeIndex	line_join_style;
} PEXExtPCAttributes;

/* Ext macros for setting bits in a PC attribute bitmask */

#define	PEXExtSetPCAttributeMask(mask, attr) \
    if ( ((attr)) >= PEXExtPCMinShift && \
	 ((attr)) <= PEXExtPCMaxShift )	\
      (mask)[2]	|= (unsigned long) 1 <<	(	((attr)) & 0x1f); \
    else \
      (mask)[((attr)) >> 5] |= (unsigned long) 1 << ( ((attr)) & 0x1f)

#define	PEXExtSetPCAttributeMaskAll(mask) \
    (mask)[0] =	0xffffffff;	       \
    (mask)[1] =	0xffffffff;	       \
    (mask)[2] =	0x000000ff

/*
 * Ext renderer
 */
typedef	struct {
    PEXPipelineContext	pipeline_context;
    PEXStructurePath	current_path;
    PEXLookupTable	marker_bundle;
    PEXLookupTable	text_bundle;
    PEXLookupTable	line_bundle;
    PEXLookupTable	interior_bundle;
    PEXLookupTable	edge_bundle;
    PEXLookupTable	view_table;
    PEXLookupTable	color_table;
    PEXLookupTable	depth_cue_table;
    PEXLookupTable	light_table;
    PEXLookupTable	color_approx_table;
    PEXLookupTable	pattern_table;
    PEXLookupTable	text_font_table;
    PEXNameSet		highlight_incl;
    PEXNameSet		highlight_excl;
    PEXNameSet		invisibility_incl;
    PEXNameSet		invisibility_excl;
    int			renderer_state;
    PEXEnumTypeIndex	hlhsr_mode;
    PEXNPCSubVolume	npc_subvolume;
    PEXViewport		viewport;
    PEXListOfClipRect	clip_list;
    PEXNameSet		pick_incl;
    PEXNameSet		pick_excl;
    PEXStructurePath	pick_start_path;
    PEXColorSpecifier	background_color;
    Bool		clear_image;
    Bool		clear_z;
    int			echo_mode;
    PEXLookupTable	tm_binding_table;
    PEXLookupTable	tm_coord_source_table;
    PEXLookupTable	tm_composition_table;
    PEXLookupTable	tm_sampling_table;
} PEXExtRendererAttributes;

/* Ext macros for setting bits in a renderer attribute bitmask */

#define	PEXExtSetRendererAttributeMask(mask, attr) \
    if ( ((attr)) >= PEXExtRAMinShift && \
	 ((attr)) <= PEXExtRAMaxShift )	\
      (mask)[1]	|= (unsigned long) 1 <<	(	((attr)) & 0x1f); \
    else \
      (mask)[0]	|= ((attr))

/*
 * Note	that PEXExtSetRendererAttributeMaskAll does not	touch bit 30 & 31
 * in mask[0]. 
 *
 *	 mask [0]		     mask [1]
 *	 _________________	   _________________
 *	|_________________|	  |_________________|
 *	  \		 \		   \	   \
 *	 bit 29	   -	bit 0		  bit 3	- bit 0
 *	 existing attributes		Extended Attributes
 */

#define	PEXExtSetRendererAttributeMaskAll(mask)	\
    (mask)[0] =	0x3fffffff;	       \
    (mask)[1] =	0x0000000f


/*
 * Ext look up table
 */
typedef	struct {
    PEXExtTMDescription	tm_description_id;
    PEXTableIndex	coord_source_index;
    PEXTableIndex	composition_index;
    PEXTableIndex	sampling_index;
} PEXExtTMBindingEntry;

typedef	struct {
    PEXEnumTypeIndex	tm_source;
    unsigned short int	fp_data_index;
    PEXMatrix		orientation;
} PEXExtTMCoordSourceEntry;

typedef	struct {
    unsigned short int	length;		/* Implementation	*/
    char		*imp_dep;	/* dependent data	*/
} PEXExtImpDepData;

typedef	struct {
    PEXEnumTypeIndex		method;
    unsigned short		reserved;
    union {
	PEXColorSpecifier	decal_bkgd_color;
	struct {
	    unsigned short	channel_selector;	
	    unsigned short	reserved;        	
	    PEXColorSpecifier	color;
	} blend_env;
	struct {
	    unsigned short	channel_selector;	
	    unsigned short	reserved;        	
	    PEXColorSpecifier	color1;
	    PEXColorSpecifier	color2;
	} blend_repl;
	PEXExtImpDepData	imp_dep;
    } data;
} PEXExtTMCompositionEntry;

typedef	struct {
    PEXEnumTypeIndex		minification_method;
    PEXEnumTypeIndex		magnification_method;
    PEXEnumTypeIndex		t0_boundary_condition;
    PEXEnumTypeIndex		t1_boundary_condition;
    PEXEnumTypeIndex		t2_boundary_condition;
    PEXEnumTypeIndex		boundary_clamp_color_source;
    PEXColorSpecifier		clamp_color;
    float			depth_sampling_bias_hint;
    float			t0_frequency_hint;
    float			t1_frequency_hint;
    float			t2_frequency_hint;
} PEXExtTMSamplingEntry;


/*
 * Ext Texture Maps
 */
/* Ext texels */
typedef	struct	{
    float		luminance;	/* Valid range : [0.0,1.0]	*/
} PEXExtTexelLuminance;

typedef	struct {
    unsigned char	luminance;	/* Valid range : [0,255]	*/
    unsigned char	reserved1;	                                   
    unsigned short      reserved2;	                                   
} PEXExtTexelLuminance8;

typedef	struct{
    unsigned short	luminance;	/* Valid range : [0,65535]	*/
    unsigned short      reserved;	                                   
} PEXExtTexelLuminance16;

typedef	struct {
    float		luminance;	/* Valid range : [0.0,1.0]	*/
    float		alpha;		/* Valid range : [0.0,1.0]	*/
} PEXExtTexelLuminanceAlpha;

typedef	struct {
    unsigned char	luminance;	/* Valid range : [0,255]	*/
    unsigned char	alpha;		/* Valid range : [0,255]	*/
    unsigned short      reserved;	                                   
} PEXExtTexelLuminanceAlpha8;

typedef	struct {
    unsigned short	luminance;	/* Valid range : [0,65535]	*/
    unsigned short	alpha;		/* Valid range : [0,65535]	*/
} PEXExtTexelLuminanceAlpha16;

typedef	struct {
    float		red;
    float		green;		/* Valid range : [0.0,1.0]	*/
    float		blue;
} PEXExtTexelRGB;

typedef	struct {
    unsigned char	red;
    unsigned char	green;		/* Valid range : [0,255]	*/
    unsigned char	blue;
    unsigned char	reserved;	                                   
} PEXExtTexelRGB8;

typedef	struct {
    unsigned short	red;
    unsigned short	green;		/* Valid range : [0,65535]	*/
    unsigned short	blue;
    unsigned short      reserved;	                                   
} PEXExtTexelRGB16;

typedef	struct {
    float		red;
    float		green;		/* Valid range : [0.0,1.0]	*/
    float		blue;
    float		alpha;
} PEXExtTexelRGBAlpha;

typedef	struct {
    unsigned char	red;
    unsigned char	green;		/* Valid range : [0,255]	*/
    unsigned char	blue;
    unsigned char	alpha;
} PEXExtTexelRGBAlpha8;

typedef	struct {
    unsigned short	red;
    unsigned short	green;		/* Valid range : [0,65535]	*/
    unsigned short	blue;
    unsigned short	alpha;
} PEXExtTexelRGBAlpha16;


typedef	struct {
    unsigned short int		t0;
    unsigned short int		t1;
    unsigned short int		t2;
} PEXExtTexelDimension;

typedef	struct {
    PEXExtTexelDimension	dimension;
    union {
	PEXExtTexelLuminance		*luminance;
	PEXExtTexelLuminance8		*luminance8;
	PEXExtTexelLuminance16		*luminance16;
	PEXExtTexelLuminanceAlpha	*luminance_alpha;
	PEXExtTexelLuminanceAlpha8	*luminance_alpha8;
	PEXExtTexelLuminanceAlpha16	*luminance_alpha16;
	PEXExtTexelRGB			*rgb;
	PEXExtTexelRGB8			*rgb8;
	PEXExtTexelRGB16		*rgb16;
	PEXExtTexelRGBAlpha		*rgb_alpha;
	PEXExtTexelRGBAlpha8		*rgb_alpha8;
	PEXExtTexelRGBAlpha16		*rgb_alpha16;
    } array;
} PEXExtTexelArray;

/* Ext texture description */

typedef	struct {
    union {
	struct {
	    PEXMatrix		matrix;		/* reflection transform	*/
	} reflection;
	struct {
		float	p0[4];			/* linear equation p0 */
		float	p1[4];			/* linear equation p1 */
	} linear;
	PEXExtImpDepData	imp_dep;	/* extensions */
    } data;
} PEXExtTMParameterizationData;

typedef	struct {
    union {
	struct {
	    PEXEnumTypeIndex	tm_type;	/* texture type	*/
	    PEXEnumTypeIndex	texel_type;	/* texel type */
	    unsigned short int	num_levels;	/* number of map levels	*/
	} color;
    } data;
} PEXExtTMDomainData;

typedef	struct {
    PEXEnumTypeIndex		 projection;	  /* projection	method */
    PEXExtTMParameterizationData param_data;	  /* parameterization data */
    PEXEnumTypeIndex		 coord_source;	  /* coord, or norm */
    unsigned short int		 fp_data_index;	  /* location for t0, t1 */
    PEXMatrix			 mc_transform;	  /* MC	transform */
} PEXExtTMCoordData;


/*
 * Extended encode and decode
 */

typedef	struct {
    unsigned short oc_type;
    union {
	struct {
	    unsigned long count;
	    PEXName *names;
	} AddToNameSet;
	struct {
	    int	length;
	    char *data;
	} ApplicationData;
	struct {
	    PEXCoord point1;
	    PEXCoord point2;
	    PEXCoord point3;
	    unsigned int col_count;
	    unsigned int row_count;
	    PEXTableIndex *color_indices;
	} CellArray;
	struct {
	    PEXCoord2D point1;
	    PEXCoord2D point2;
	    unsigned int col_count;
	    unsigned int row_count;
	    PEXTableIndex *color_indices;
	} CellArray2D;
	struct {
	    PEXCoord origin;
	    PEXCoord offset;
	    unsigned int count;
	    PEXEncodedTextData *encoded_text;
	} EncodedAnnoText;
	struct {
	    PEXCoord2D origin;
	    PEXCoord2D offset;
	    unsigned int count;
	    PEXEncodedTextData *encoded_text;
	} EncodedAnnoText2D;
	struct {
	    PEXCoord origin;
	    PEXVector vector1;
	    PEXVector vector2;
	    unsigned int count;
	    PEXEncodedTextData *encoded_text;
	} EncodedText;
	struct {
	    PEXCoord2D origin;
	    unsigned int count;
	    PEXEncodedTextData *encoded_text;
	} EncodedText2D;
	struct {
	    PEXStructure structure;
	} ExecuteStructure;
	struct {
	    PEXCoord point1;
	    PEXCoord point2;
	    PEXCoord point3;
	    unsigned int col_count;
	    unsigned int row_count;
	    int	color_type;
	    PEXArrayOfColor colors;
	} ExtendedCellArray;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    unsigned int count;
	    PEXCoord *points;
	} FillArea;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    unsigned int count;
	    PEXCoord2D *points;
	} FillArea2D;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    int	contour_hint;
	    unsigned int count;
	    PEXListOfCoord *point_lists;
	} FillAreaSet;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    int	contour_hint;
	    unsigned int count;
	    PEXListOfCoord2D *point_lists;
	} FillAreaSet2D;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    int	contour_hint;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    unsigned int count;
	    PEXFacetData facet_data;
	    PEXListOfVertex *vertex_lists;
	} FillAreaSetWithData;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    PEXFacetData facet_data;
	    unsigned int count;
	    PEXArrayOfVertex vertices;
	} FillAreaWithData;
	struct {
	    long gdp_id;
	    unsigned int count;
	    PEXCoord *points;
	    unsigned long length;
	    char *data;
	} GDP;
	struct {
	    long gdp_id;
	    unsigned int count;
	    PEXCoord2D *points;
	    unsigned long length;
	    char *data;
	} GDP2D;
	struct {
	    long id;
	    int	length;
	    char *data;
	} GSE;
	struct {
	    long label;
	} Label;
	struct {
	    unsigned int count;
	    PEXCoord *points;
	} Markers;
	struct {
	    unsigned int count;
	    PEXCoord2D *points;
	} Markers2D;
	struct {
	    int	rationality;
	    int	order;
	    float *knots;
	    unsigned int count;
	    PEXArrayOfCoord points;
	    double tmin;
	    double tmax;
	} NURBCurve;
	struct {
	    int	rationality;
	    int	uorder;
	    int	vorder;
	    float *uknots;
	    float *vknots;
	    unsigned int col_count;
	    unsigned int row_count;
	    PEXArrayOfCoord points;
	    unsigned int curve_count;
	    PEXListOfTrimCurve *trim_curves;
	} NURBSurface;
	struct {
	    unsigned int count;
	    PEXCoord *points;
	} Polyline;
	struct {
	    unsigned int count;
	    PEXCoord2D *points;
	} Polyline2D;
	struct {
	    unsigned int vertex_attributes;
	    int	color_type;
	    unsigned int count;
	    PEXListOfVertex *vertex_lists;
	} PolylineSetWithData;
	struct {
	    int	shape_hint;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    PEXArrayOfFacetData	facet_data;
	    unsigned int col_count;
	    unsigned int row_count;
	    PEXArrayOfVertex vertices;
	} QuadrilateralMesh;
	struct {
	    unsigned long count;
	    PEXName *names;
	} RemoveFromNameSet;
	struct {
	    int	halignment;
	    int	valignment;
	} SetATextAlignment;
	struct {
	    double height;
	} SetATextHeight;
	struct {
	    int	path;
	} SetATextPath;
	struct {
	    int	style;
	} SetATextStyle;
	struct {
	    PEXVector2D	vector;
	} SetATextUpVector;
	struct {
	    int	style;
	} SetBFInteriorStyle;
	struct {
	    int	index;
	} SetBFInteriorStyleIndex;
	struct {
	    PEXReflectionAttributes attributes;
	} SetBFReflectionAttributes;
	struct {
	    int	model;
	} SetBFReflectionModel;
	struct {
	    int	color_type;
	    PEXColor color;
	} SetBFSurfaceColor;
	struct {
	    unsigned int index;
	} SetBFSurfaceColorIndex;
	struct {
	    int	method;
	} SetBFSurfaceInterpMethod;
	struct {
	    double expansion;
	} SetCharExpansion;
	struct {
	    double height;
	} SetCharHeight;
	struct {
	    double spacing;
	} SetCharSpacing;
	struct {
	    PEXVector2D	vector;
	} SetCharUpVector;
	struct {
	    unsigned int index;
	} SetColorApproxIndex;
	struct {
	    int	method;
	    double tolerance;
	} SetCurveApprox;
	struct {
	    unsigned int index;
	} SetDepthCueIndex;
	struct {
	    unsigned int index;
	} SetEdgeBundleIndex;
	struct {
	    int	mode;
	} SetFacetCullingMode;
	struct {
	    int	flag;
	} SetFacetDistinguishFlag;
	struct {
	    PEXMatrix transform;
	} SetGlobalTransform;
	struct {
	    PEXMatrix3x3 transform;
	} SetGlobalTransform2D;
	struct {
	    unsigned long hlhsr_id;
	} SetHLHSRID;
	struct {
	    unsigned long attribute;
	    int	asf;
	} SetIndividualASF;
	struct {
	    unsigned int index;
	} SetInteriorBundleIndex;
	struct {
	    int	style;
	} SetInteriorStyle;
	struct {
	    int	index;
	} SetInteriorStyleIndex;
	struct {
	    unsigned int enable_count;
	    PEXTableIndex *enable;
	    unsigned int disable_count;
	    PEXTableIndex *disable;
	} SetLightSourceState;
	struct {
	    unsigned int index;
	} SetLineBundleIndex;
	struct {
	    int	color_type;
	    PEXColor color;
	} SetLineColor;
	struct {
	    unsigned int index;
	} SetLineColorIndex;
	struct {
	    int	line_type;
	} SetLineType;
	struct {
	    double width;
	} SetLineWidth;
	struct {
	    int	composition;
	    PEXMatrix transform;
	} SetLocalTransform;
	struct {
	    int	composition;
	    PEXMatrix3x3 transform;
	} SetLocalTransform2D;
	struct {
	    unsigned int index;
	} SetMarkerBundleIndex;
	struct {
	    int	color_type;
	    PEXColor color;
	} SetMarkerColor;
	struct {
	    unsigned int index;
	} SetMarkerColorIndex;
	struct {
	    double scale;
	} SetMarkerScale;
	struct {
	    int	marker_type;
	} SetMarkerType;
	struct {
	    int	flag;
	} SetModelClipFlag;
	struct {
	    int	op;
	    unsigned int count;
	    PEXHalfSpace *half_spaces;
	} SetModelClipVolume;
	struct {
	    int	op;
	    unsigned int count;
	    PEXHalfSpace2D *half_spaces;
	} SetModelClipVolume2D;
	struct {
	    int	shape_hint;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    unsigned int edge_attributes;
	    int	contour_hint;
	    int	contours_all_one;
	    int	color_type;
	    unsigned int set_count;
	    PEXArrayOfFacetData	facet_data;
	    unsigned int vertex_count;
	    PEXArrayOfVertex vertices;
	    unsigned int index_count;
	    PEXSwitch *edge_flags;
	    PEXConnectivityData	*connectivity;
	} SetOfFillAreaSets;
	struct {
	    int	psc_type;
	    PEXPSCData characteristics;
	} SetParaSurfCharacteristics;
	struct {
	    PEXCoord ref_point;
	    PEXVector vector1;
	    PEXVector vector2;
	} SetPatternAttributes;
	struct {
	    PEXCoord2D ref_point;
	} SetPatternAttributes2D;
	struct {
	    double width;
	    double height;
	} SetPatternSize;
	struct {
	    unsigned long pick_id;
	} SetPickID;
	struct {
	    int	method;
	} SetPolylineInterpMethod;
	struct {
	    PEXReflectionAttributes attributes;
	} SetReflectionAttributes;
	struct {
	    int	model;
	} SetReflectionModel;
	struct {
	    int	model;
	} SetRenderingColorModel;
	struct {
	    int	method;
	    double utolerance;
	    double vtolerance;
	} SetSurfaceApprox;
	struct {
	    int	color_type;
	    PEXColor color;
	} SetSurfaceColor;
	struct {
	    unsigned int index;
	} SetSurfaceColorIndex;
	struct {
	    int	color_type;
	    PEXColor color;
	} SetSurfaceEdgeColor;
	struct {
	    unsigned int index;
	} SetSurfaceEdgeColorIndex;
	struct {
	    int	flag;
	} SetSurfaceEdgeFlag;
	struct {
	    int	edge_type;
	} SetSurfaceEdgeType;
	struct {
	    double width;
	} SetSurfaceEdgeWidth;
	struct {
	    int	method;
	} SetSurfaceInterpMethod;
	struct {
	    int	halignment;
	    int	valignment;
	} SetTextAlignment;
	struct {
	    unsigned int index;
	} SetTextBundleIndex;
	struct {
	    int	color_type;
	    PEXColor color;
	} SetTextColor;
	struct {
	    unsigned int index;
	} SetTextColorIndex;
	struct {
	    unsigned int index;
	} SetTextFontIndex;
	struct {
	    int	path;
	} SetTextPath;
	struct {
	    int	precision;
	} SetTextPrecision;
	struct {
	    unsigned int index;
	} SetViewIndex;
	struct {
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    PEXArrayOfFacetData	facet_data;
	    unsigned int count;
	    PEXArrayOfVertex vertices;
	} TriangleStrip;
	struct {
	    PEXCoord2D center;
	    double radius;
	} ExtCircle2D;
	struct {
	    PEXCoord2D center;
	    double radius;
	    double start;
	    double stop;
	} ExtCircularArc2D;
	struct {
	    PEXCoord center;
	    PEXVector major;
	    PEXVector minor;
	} ExtEllipse;
	struct {
	    PEXCoord2D center;
	    PEXVector2D	major;
	    PEXVector2D	minor;
	} ExtEllipse2D;
	struct {
	    PEXCoord center;
	    PEXVector major;
	    PEXVector minor;
	    double start;
	    double stop;
	} ExtEllipticalArc;
	struct {
	    PEXCoord2D center;
	    PEXVector2D	major;
	    PEXVector2D	minor;
	    double start;
	    double stop;
	} ExtEllipticalArc2D;
	struct {
	    int	shape_hint;
	    int	ignore_edges;
	    int	contour_hint;
	    unsigned int vertex_fp_data_size;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    unsigned int count;
	    PEXFacetData facet_data;
	    PEXExtListOfVertex *vertex_lists;
	} ExtFillAreaSetWithData;
	struct {
	    int	shape_hint;
	    unsigned int vertex_fp_data_size;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    PEXArrayOfFacetData	facet_data;
	    unsigned int col_count;
	    unsigned int row_count;
	    PEXExtArrayOfVertex	vertices;
	} ExtQuadrilateralMesh;
	struct {
	    unsigned int count;
	    PEXTableIndex *textures;
	} ExtSetActiveTextures;
	struct {
	    unsigned int count;
	    PEXTableIndex *textures;
	} ExtSetBFActiveTextures;
	struct {
	    int	style;
	} ExtSetLineCapStyle;
	struct {
	    int	style;
	} ExtSetLineJoinStyle;
	struct {
	    int	shape_hint;
	    unsigned int vertex_fp_data_size;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    unsigned int edge_attributes;
	    int	contour_hint;
	    int	contours_all_one;
	    int	color_type;
	    unsigned int set_count;
	    PEXArrayOfFacetData	facet_data;
	    unsigned int vertex_count;
	    PEXExtArrayOfVertex	vertices;
	    unsigned int index_count;
	    PEXSwitch *edge_flags;
	    PEXConnectivityData	*connectivity;
	} ExtSetOfFillAreaSets;
	struct {
	    int	mode;
	    int	blend_op;
	} ExtSetPrimitiveAA;
	struct {
	    int	method;
	} ExtSetTMPerspectiveCorrection;
	struct {
	    int	optimization;
	    unsigned int count;
	    PEXTableIndex  *priorities;
	} ExtSetTMResourceHints;
	struct {
	    int	frequency;
	} ExtSetTMSampleFrequency;
	struct {
	    unsigned int vertex_fp_data_size;
	    unsigned int facet_attributes;
	    unsigned int vertex_attributes;
	    int	color_type;
	    PEXArrayOfFacetData	facet_data;
	    unsigned int count;
	    PEXExtArrayOfVertex	vertices;
	} ExtTriangleStrip;
	struct {
            unsigned long length;
            char *data;
	} ExtVendorExtOC;  
    } data;
} PEXExtOCData;

/*
 * Ext constants for utilities
 */

/* Ext constants for utilities error return status */
#define	PEXExtBadDimension		1
#define	PEXExtBadDomain			2
#define	PEXExtBadTMType			3
#define	PEXExtBadTexelData		4	
#define	PEXExtBadTexelDimension		5
#define	PEXExtBadTexelType		6
#define	PEXExtBadTMAlloc		7
#define	PEXExtBadPrimitive		8
#define	PEXExtBadXResource		9
#define	PEXExtBadAlloc			10
#define	PEXExtBadValue			11
				       
/*
 * Projection types for	utilities
 */
#define	PEXExtTMProjectionSphereWC	  (short) 0x9000
#define	PEXExtTMProjectionCylinderWC	  (short) 0x9001
#define	PEXExtTMProjectionLinearWC	  (short) 0x9002

_XFUNCPROTOBEGIN

/*
 * Ext function	declarations
 */

extern void PEXExtChangePipelineContext(
#if NeedFunctionPrototypes
    Display *			/* display */,
    PEXPipelineContext		/* context */,
    unsigned long *		/* value_mask */,
    PEXExtPCAttributes *	/* values */
#endif
);

extern void PEXExtChangeRenderer(
#if NeedFunctionPrototypes
    Display *			/* display */,
    PEXRenderer			/* renderer */,
    unsigned long *		/* value_mask */,
    PEXExtRendererAttributes *	/* values */
#endif
);

extern void PEXExtCircle2D(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    PEXCoord2D *	/* center */,
    double		/* radius */
#endif
);

extern void PEXExtCircularArc2D(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    PEXCoord2D *	/* center */,
    double		/* radius */,
    double		/* start */,
    double		/* stop	*/
#endif
);

extern unsigned	long PEXExtCountOCs(
#if NeedFunctionPrototypes
    int			/* float_format	*/, 
    unsigned long	/* length */,
    char *		/* encoded_ocs */
#endif
);

extern int PEXExtCreateFilteredTM(
#if NeedFunctionPrototypes
    int				/* domain */, 
    PEXExtTMDomainData *	/* domain_data */,
    unsigned int		/* power_of_two_required */,
    unsigned int		/* square_tm_required */,
    PEXExtTexelArray *		/* base_map */,
    PEXExtTexelArray **		/* texel_array */
#endif
);

extern int PEXExtCreateFilteredTMFromWindow(
#if NeedFunctionPrototypes
    Display *			/* display */,
    int				/* domain */, 
    PEXExtTMDomainData *	/* domain_data */,
    unsigned int      		/* power_of_two_required */,
    unsigned int     		/* square_tm_required */,
    unsigned int		/* luminance_channel_selector */,
    XID				/* base_color_window */,
    unsigned int		/* alpha_channel_selector */,
    XID				/* base_alpha_window */,
    PEXExtTexelArray **		/* texel_array */
#endif
);

extern PEXExtTextureMap	PEXExtCreateTM(
#if NeedFunctionPrototypes
    Display *			/* display */,
    int				/* domain */, 
    PEXExtTMDomainData *	/* domain_data */,
    PEXExtTexelArray *		/* texel_arrays	*/
#endif
);

extern PEXExtTMDescription PEXExtCreateTMDescription(
#if NeedFunctionPrototypes
    Display *			   /* display */,
    int				   /* parameterization */,
    PEXExtTMParameterizationData * /* param_data */,
    int				   /* tm_rendering_order */,
    unsigned int  		   /* count */,
    PEXExtTextureMap *		   /* tm_ids */
#endif
);

extern PEXExtOCData *PEXExtDecodeOCs(
#if NeedFunctionPrototypes
    int			/* float_format	*/, 
    unsigned long	/* oc_count */,
    unsigned long	/* length */, 
    char *		/* encoded_ocs */
#endif
);

extern void PEXExtEllipse(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    PEXCoord *		/* center */,
    PEXVector *		/* major */,
    PEXVector *		/* minor */
#endif
);

extern void PEXExtEllipse2D(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    PEXCoord2D *	/* center */,
    PEXVector2D	*	/* major */,
    PEXVector2D	*	/* minor */
#endif
);

extern void PEXExtEllipticalArc(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    PEXCoord *		/* center */,
    PEXVector *		/* major */,
    PEXVector *		/* minor */,
    double		/* start */,
    double		/* stop	*/
#endif
);

extern void PEXExtEllipticalArc2D(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    PEXCoord2D *	/* center */,
    PEXVector2D	*	/* major */,
    PEXVector2D	*	/* minor */,
    double		/* start */,
    double		/* stop	*/
#endif
);

extern char *PEXExtEncodeOCs(
#if NeedFunctionPrototypes
    int			/* float_format	*/, 
    unsigned long	/* oc_count */,
    PEXExtOCData *	/* oc_data */, 
    unsigned long *	/* length_return */
#endif
);

extern Status PEXExtFetchElements(
#if NeedFunctionPrototypes
    Display *		/* display */,
    PEXStructure	/* structure */, 
    int			/* whence1 */, 
    long		/* offset1 */,
    int			/* whence2 */, 
    long		/* offset2 */, 
    int			/* float_format	*/,
    unsigned long *	/* count_return	*/,
    unsigned long *	/* length_return */,
    char **		/* ocs_return */
#endif
);

extern Status PEXExtFetchElementsAndSend(
#if NeedFunctionPrototypes
    Display *		/* src_display */,
    PEXStructure	/* structure */, 
    int			/* whence1 */, 
    long		/* offset1 */,
    int			/* whence2 */, 
    long		/* offset2 */, 
    Display *		/* dst_display */,
    XID			/* resource_id */, 
    PEXOCRequestType	/* req_type */
#endif
);

extern void PEXExtFillAreaSetWithData(
#if NeedFunctionPrototypes
    Display *			/* display */,
    XID				/* resource_id */,
    PEXOCRequestType		/* req_type */,
    int				/* shape_hint */,
    int				/* ignore_edges	*/,
    int				/* contour_hint	*/,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    unsigned int		/* count */,
    PEXFacetData *		/* facet_data */,
    PEXExtListOfVertex *	/* vertex_lists	*/
#endif
);

extern void PEXExtFreeFilteredTM(
#if NeedFunctionPrototypes
    int				/* domain */, 
    PEXExtTMDomainData *	/* domain_data */,
    PEXExtTexelArray *		/* texel_array */
#endif
);

extern void PEXExtFreeTableEntries(
#if NeedFunctionPrototypes
    int				/* table_type */,
    unsigned int		/* count */,
    PEXPointer			/* entries */
#endif
);									

extern void PEXExtFreeOCData(
#if NeedFunctionPrototypes
    unsigned long		/* count */, 
    PEXExtOCData *		/* oc_data */
#endif
);

extern void PEXExtFreePCAttributes(		 
#if NeedFunctionPrototypes
    PEXExtPCAttributes *	/* values */
#endif
);

extern void PEXExtFreeRendererAttributes(	       
#if NeedFunctionPrototypes
    PEXExtRendererAttributes *	/* values */
#endif
);

extern void PEXExtFreeTM(
#if NeedFunctionPrototypes
    Display *			/* display */,
    PEXExtTextureMap		/* texture_map */
#endif
);

extern void PEXExtFreeTMDescription(
#if NeedFunctionPrototypes
    Display *			/* display */,
    PEXExtTMDescription		/* tm_description */
#endif
);

extern int PEXExtGetSizeOCs(
#if NeedFunctionPrototypes
    int				/* float_format	*/, 
    int				/* oc_count */,	
    PEXExtOCData *		/* oc_data */
#endif
);

extern PEXExtPCAttributes *PEXExtGetPipelineContext(
#if NeedFunctionPrototypes
    Display *			/* display */,
    PEXPipelineContext		/* context */,
    unsigned long *		/* value_mask */
#endif
);

extern PEXExtRendererAttributes	*PEXExtGetRendererAttributes(
#if NeedFunctionPrototypes
    Display *			/* display */,
    PEXRenderer			/* renderer */,
    unsigned long *		/* value_mask */
#endif
);

extern int PEXExtGetTableEntries(
#if NeedFunctionPrototypes
    Display *			/* display */, 
    PEXLookupTable		/* table */,
    unsigned int		/* start */, 
    unsigned int		/* count */, 
    int				/* value_type */,
    int	*			/* table_type_return */, 
    PEXPointer *		/* entries_return */
#endif
);
extern PEXPointer PEXExtGetTableEntry(
#if NeedFunctionPrototypes
    Display *			/* display */, 
    PEXLookupTable		/* table */,
    unsigned int		/* index */, 
    int				/* value_type */, 
    int	*			/* status_return */,
    int	*			/* table_type_return */
#endif
);

extern void PEXExtQuadrilateralMesh(
#if NeedFunctionPrototypes
    Display *			/* display */,
    XID				/* resource_id */,
    PEXOCRequestType		/* req_type */,
    int				/* shape_hint */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    PEXArrayOfFacetData		/* facet_data */,
    unsigned int		/* col_count */,
    unsigned int		/* row_count */,
    PEXExtArrayOfVertex		/* vertices */
#endif
);

extern int PEXExtQueryColorApprox(
#if NeedFunctionPrototypes
    Display *			/* display */, 
    Drawable			/* drawable */,
    PEXColorApproxEntry	*	/* color_approx	*/, 
    unsigned long *		/* count_return	*/,
    PEXColorApproxEntry	**	/* color_approx_return */, 
    int	*			/* all_return */
#endif
);

extern void PEXExtSetActiveTextures(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    unsigned int	/* count */,
    PEXTableIndex *	/* textures */
#endif
);
 
extern void PEXExtSetBFActiveTextures(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    unsigned int	/* count */,
    PEXTableIndex *	/* textures */
#endif
);

extern void PEXExtSetLineCapStyle(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    int			/* style */
#endif
);

extern void PEXExtSetLineJoinStyle(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    int			/* style */
#endif
);

extern void PEXExtSetOfFillAreaSets(
#if NeedFunctionPrototypes
    Display *			/* display */,
    XID				/* resource_id */,
    PEXOCRequestType		/* req_type */,
    int				/* shape_hint */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    unsigned int		/* edge_attributes */,
    int				/* contour_hint	*/,
    int				/* contours_all_one */,
    int				/* color_type */,
    unsigned int		/* set_count */,
    PEXArrayOfFacetData		/* facet_data */,
    unsigned int		/* vertex_count	*/,
    PEXExtArrayOfVertex		/* vertices */,
    unsigned int		/* index_count */,
    PEXSwitch *			/* edge_flags */,
    PEXConnectivityData	*	/* connectivity	*/
#endif
);

extern void PEXExtSetPrimitiveAA(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    int			/* mode	*/,
    int			/* blend_op */
#endif
);

extern void PEXExtSetTableEntries(
#if NeedFunctionPrototypes
    Display *		/* display */,
    PEXLookupTable	/* table */,
    unsigned int	/* start */, 
    unsigned int	/* count */, 
    int			/* table_type */,
    PEXPointer		/* entries */
#endif
);

extern void PEXExtSetTMPerspectiveCorrection(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    int			/* method */
#endif
);

extern void PEXExtSetTMResourceHints(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    int			/* optimization_hint */,
    unsigned int	/* count */,
    PEXTableIndex *	/* priorities */
#endif
);

extern void PEXExtSetTMSampleFrequency(
#if NeedFunctionPrototypes
    Display *		/* display */,
    XID			/* resource_id */,
    PEXOCRequestType	/* req_type */,
    int			/* frequency */
#endif
);

extern int PEXExtTMCoordFillAreaSetWithData(
#if NeedFunctionPrototypes
    PEXExtTMCoordData *		/* tm_coord_data */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    unsigned int		/* count */,
    PEXFacetData *		/* facet_data */,
    PEXExtListOfVertex *	/* vertex_lists	*/
#endif
);

extern int PEXExtTMCoordSetOfFillAreaSets(
#if NeedFunctionPrototypes
    PEXExtTMCoordData *		/* tm_coord_data */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    unsigned int		/* set_count */,
    PEXArrayOfFacetData		/* facet_data */,
    unsigned int		/* vertex_count	*/,
    PEXExtArrayOfVertex		/* vertices */,
    unsigned int		/* index_count */,
    PEXConnectivityData	*	/* connectivity	*/
#endif
);

extern int PEXExtTMCoordTriangleStrip(
#if NeedFunctionPrototypes
    PEXExtTMCoordData *		/* tm_coord_data */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    PEXArrayOfFacetData		/* facet_data */,
    unsigned int		/* count */,
    PEXExtArrayOfVertex		/* vertices */
#endif
);

extern int PEXExtTMCoordQuadrilateralMesh(
#if NeedFunctionPrototypes
    PEXExtTMCoordData *		/* tm_coord_data */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    PEXArrayOfFacetData		/* facet_data */,
    unsigned int		/* col_count */,
    unsigned int		/* row_count */,
    PEXExtArrayOfVertex		/* vertices */
#endif
);

extern void PEXExtTriangleStrip(
#if NeedFunctionPrototypes
    Display *			/* display */,
    XID				/* resource_id */,
    PEXOCRequestType		/* req_type */,
    unsigned int		/* vertex_fp_data_size */,
    unsigned int		/* facet_attributes */,
    unsigned int		/* vertex_attributes */,
    int				/* color_type */,
    PEXArrayOfFacetData		/* facet_data */,
    unsigned int		/* count */,
    PEXExtArrayOfVertex		/* vertices */
#endif
);

_XFUNCPROTOEND

#endif /* PEXEXTLIB_H */

